<template>
  <div class="d-md-flex align-items-center justify-content-betwenn flex-wrap p-2 pb-4 contenedorPrincipal">
    <div class="col-4 ms-3 mt-3">
      <label for="solicitante" class="form-label  d-block">Solicitante:</label>
      <auto-complete class="d-inline w-25" v-model="form.solicitante" :elements="solicitantesStore.solicitantes"
        initKey="" placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled='!habilitarBusq' :required="true"
        autocomplete="off" id="solicitante" />

      <button type="button" class="d-inline btn btn-principal px-3 ms-3" alt="Ver cupos del solicitante"
        title="Ver cupos del solicitante" :disabled='!habilitarBusq' @click="validarVerCupos()"> Ver cupos
      </button>
      <div v-show='!habilitarBusq' class="spinner-border text-secondary" role="status">
        <span class="sr-only">Cargando...</span>
      </div>
      <p v-show='haySolicTotalDisp === false' class="text-danger" v-html='"El solicitante no tiene cupo disponible"'></p>
      <p v-show='haySolicTotalDisp === true' class="text-success"
        v-html='"Cupo disponible del solicitante: " + importeMostrar(form.solicitante?.tot_disponible)'></p>
      <Modal ref="cuposModal" :size="'lg'" :title="cuposTitulo">
        <CuposModal :parametros="cuposParametros"></CuposModal>
      </Modal>
    </div>
    <div class="col-3 ms-3 mt-3 ">
      <label for="becario" class="form-label">Becario:</label>
      <auto-complete v-model="form.becario" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" autocomplete="off" id="becario" />
    </div>
    <div class="col-3  mt-3 ">
      <label for="apoderado" class="form-label">Apoderado:</label>
      <auto-complete v-model="form.apoderado" :elements="becariosStore.becarios" initKey=""
        placeholder="Apellido/s y Nombre/s" :minLength="2" :disabled="false" autocomplete="off" id="apoderado" />
    </div>

    <!-- PANEL MAS FILTROS -->
    <div class="col-12 row" v-show='verFiltrosAdic'>
      <div class="col-3 ms-3  mt-3">
        <label for="bloque" class="form-label">Bloque Pol&iacute;tico:</label>
        <auto-complete v-model="form.bloque" :elements="bloquesStore.bloques" initKey="" placeholder="Dependencia"
          :minLength="2" :disabled="false" autocomplete="off" id="bloque" />
      </div>
      <div class="col-3 ms-3  mt-3">
        <label for="baproSucursal" class="form-label">Sucursal Bapro:</label>
        <auto-complete v-model="form.baproSucursal" :elements="baproSucursalesStore.getBaproSucursales()" initKey=""
          placeholder="Sucursal" :minLength="2" :disabled="false" autocomplete="off" id="baproSucursal" />
      </div>
      <div class="col-3 ms-3  mt-3">
        <label for="responsable" class="form-label">Responsable:</label>
        <auto-complete v-model="form.responsable" :elements="solicitantesStore.solicYProyectos" initKey=""
          placeholder="Responsable" :minLength="2" :disabled="false" autocomplete="off" id="responsable" />
      </div>

      <div class="col-2 ms-3 mt-3">
        <label for="estado" class="form-label">Estado:</label>
        <select v-model="form.estado" class="form-select form-select-sm pe-5" id="estado">
          <option :value="null" v-text="'--Todos--'"></option>
          <option :value="{ id_estado: 1, c_estado: 'A', d_estado: 'Activo' }" v-text="'Activo'"></option>
          <option :value="{ id_estado: 2, c_estado: 'B', d_estado: 'Baja' }" v-text="'Baja'"></option>
        </select>
      </div>

      <div class="col-3 ms-3 mt-3">
        <label for="f_desde" class="form-label" style="margin-top: 2px !important">Fecha Desde:</label>
        <input required type="date" v-model="form.f_desde" class="form-control" autocomplete="off" id="f_desde" />
      </div>

      <div class="col-3 ms-3 mt-3">
        <label for="f_hasta" class="form-label" style="margin-top: 2px !important">Fecha Hasta:</label>
        <input required type="date" v-model="form.f_hasta" class="form-control" autocomplete="off" id="f_hasta" />
      </div>
      <div class="col-5 ms-3 mt-3">
        <label for="expediente" class="form-label">Expediente:</label>
        <input-expediente class="ms-1" v-model='form.expediente' :url-server='urlComun' :tipo='"B"' :disabled='false'
          :disabled-origen='true' :id='"expediente"' />
      </div>
    </div>
    <!-- CIERRA PANEL MAS FILTROS -->

    <div class="col mt-4 text-end me-2">
      <button v-show='!verFiltrosAdic' class="btn btn-principal text-uppercase fs-7 p-2 px-1 mx-2 mt-2 fs-7"
        alt="Ver filtros adicionales" title="Ver filtros adicionales" @click="cambiarVerFiltrosAdic()">
        <i class="fa-solid fa-ellipsis  mx-1"></i>filtros
      </button>
      <button v-show='verFiltrosAdic' class="btn btn-principal text-uppercase fs-7 p-2 mx-2 mt-2"
        alt="Ocultar filtros adicionales" title="Ocultar filtros adicionales" @click="cambiarVerFiltrosAdic()">
        <i class="fa-solid fa-ellipsis-vertical mx-1"></i> Ocultar Filtros
      </button>
      <button type="button" class="btn btn-principal px-2 mt-2" alt="Buscar becas" title="Buscar becas"
        :disabled='!habilitarBusq' @click="validarBuscarBecas()">
        <i class="bi bi-search "></i>
      </button>
      <div v-show='!habilitarBusq' class="spinner-border text-secondary" role="status">
        <span class="sr-only">Cargando...</span>
      </div>
    </div>

  </div>
  <div class="mt-2 text-end" v-show='verAltaBeca'>
    <button v-show="cargaBloquesInhabilitada != 1"
      class="fs-7 text-uppercase text-white btn btn-secondary mx-1 mt-4 p-2 px-2" alt="Agregar beca" title="Agregar beca"
      @click="abrirABM()">
      <i class="bi bi-plus-square mx-1 fs-7"></i> Nueva Beca
    </button>
  </div>
  <div class="mt-2 text-end">
    <h3 v-show='cargaBloquesInhabilitada == 1' class="text-danger" v-html='"CARGA INHABILITADA"'></h3>
  </div>
</template>

<script setup lang="ts">
// Librerías
import { DateTime } from "luxon";
import { onMounted, reactive, computed, ref, watch, watchEffect, nextTick } from "vue";
import type { Ref } from "vue";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions } from "sweetalert2";
import { AutoComplete, InputExpediente, Expediente, Modal } from "@hcd-bsas/vue3-components";
import { loading, isEmpty, urlComun } from "@/shared.js";
// Componentes
import CuposModal from "@/components/becas/actualizacion/cupos/Modal.vue";
// Entidades
import { Usuariohabilitado } from "@/entities/Usuariohabilitado";
import type Solicitante from "@/entities/Solicitante";
import type Becario from "@/entities/becas/Becario";
import type Bloque from "@/entities/Bloque";
import type Estado from "@/entities/becas/Estado";
import type BaproSucursal from "@/entities/becas/BaproSucursal";
// Stores
import { useUsuariosStore } from "@/stores/usuarios";
import { usePermisosAppStore } from "@/stores/permisosApp";
import { usePeriodosStore } from "@/stores/periodos";
import { useSolicitantesStore } from "@/stores/solicitantes";
import { useBecariosStore } from "@/stores/becas/becarios";
import { useBloquesStore } from "@/stores/bloques";
import { useBaproSucursalesStore } from "@/stores/becas/baproSucursales";
import { useBecasStore } from "@/stores/becas/becas";

const usuariosStore = useUsuariosStore();
const permisosAppStore = usePermisosAppStore();
const periodosStore = usePeriodosStore();
const solicitantesStore = useSolicitantesStore();
const becariosStore = useBecariosStore();
const bloquesStore = useBloquesStore();
const baproSucursalesStore = useBaproSucursalesStore();
const becasStore = useBecasStore();

const props = withDefaults(defineProps<{
  idTablaSol: number | null
}>(), {
  idTablaSol: null
});

const emits = defineEmits(["ocultarGrilla", "mostrarGrilla", "abrirABM"]);

const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const importeMostrar = (importe: number | undefined) => (!isEmpty(importe)) ? Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe!) : null;
const expedientePorDefecto = (): Expediente => {
  return {
    id: null, origen: "I-A", numero: undefined, anio: String(periodoActivo.value!.anioActivo), alcance: 0
  }
};

const usuarioActivo = ref(null) as Ref<Usuariohabilitado | null>;
const periodoActivo = computed(() => periodosStore.periodos.activo);
const cargaBloquesInhabilitada = computed(() => periodosStore.periodos.activo?.carga_bloques_inhabilitada);
const haySolicitante = computed(() => !isEmpty(form.solicitante));
const hayFDesde = computed(() => !isEmpty(form.f_desde));
const hayFHasta = computed(() => !isEmpty(form.f_hasta));
const hayExpte = computed(() => !isEmpty(form.expediente.id));
const haySolicTotalDisp = computed(() => haySolicitante.value ? ((form.solicitante!.tot_disponible > 0) ? true : false) : null);
const verAltaBeca = computed(() => form.solicitante?.estado === "A");
const verFiltrosAdic = ref(false);
const habilitarBusq = ref(true);

const form = reactive({
  solicitante: undefined as Solicitante | undefined,
  becario: undefined as Becario | undefined,
  apoderado: undefined as Becario | undefined,
  bloque: undefined as Bloque | undefined,
  baproSucursal: undefined as BaproSucursal | undefined,
  responsable: undefined as Solicitante | undefined,
  estado: null as Estado | null,
  f_desde: null as String | null,
  f_hasta: null as String | null,
  expediente: {} as Expediente
});

const cuposModal = ref(Modal);
const cuposTitulo = computed(() =>
  'Cupos del solicitante "' + form.solicitante?.ayn + '"' +
  ' desde el ' + fechaMostrar(String(form.f_desde)) +
  ' hasta el ' + fechaMostrar(String(form.f_hasta))
);
const cuposParametros = computed(() => ({
  f_cupo_des: form.f_desde,
  f_cupo_has: form.f_hasta,
  id_tabla_sol: form.solicitante?.id_tabla_sol,
  usar_perfil_consulta: (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0
}));

watch(haySolicitante, (newValue, oldValue) => {
  if (newValue !== oldValue) {
    if (!newValue) {
      ocultarGrilla();
    }
    /*
    else if (!loading.isLoading()) {
      validarBuscarBecas();
    }
    */
    else {
      validarBuscarBecas();
    }
  }
});

function validarVerCupos() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!haySolicitante.value) {
    swal.html = 'Por favor, complete el campo "Solicitante".';
  } else if (!hayFDesde.value) {
    swal.html = 'Por favor, complete el campo "Fecha Desde".';
  } else if (!hayFHasta.value) {
    swal.html = 'Por favor, complete el campo "Fecha Hasta".';
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  verCupos();
}

function verCupos() {
  cuposModal.value?.show();
}

function cambiarVerFiltrosAdic() {
  verFiltrosAdic.value = !verFiltrosAdic.value;
}

function ocultarGrilla() {
  emits("ocultarGrilla");
}

function mostrarGrilla() {
  emits("mostrarGrilla");
}

async function validarBuscarBecas() {
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!haySolicitante.value) {
    swal.html = 'Por favor, complete el campo "Solicitante".';
  } else if (!hayFDesde.value) {
    swal.html = 'Por favor, complete el campo "Fecha Desde".';
  } else if (!hayFHasta.value) {
    swal.html = 'Por favor, complete el campo "Fecha Hasta".';
  } else if (!hayExpte.value) {
    form.expediente = expedientePorDefecto();
  }
  if (!isEmpty(swal.html)) {
    Swal.fire(swal);
    return;
  }
  buscarBecas();
}

async function buscarBecas() {
  const paramsRequest: Object = {
    id_tabla_sol: form.solicitante?.id_tabla_sol,
    id_becario: form.becario?.id_becario,
    id_apoderado: form.apoderado?.id_becario,
    id_dependen: form.bloque?.id_dependen,
    baprosuc: form.baproSucursal?.c_bapro,
    id_tabla_sol_responsable: form.responsable?.id_tabla_sol,
    estado: form.estado?.c_estado,
    f_desde: form.f_desde,
    f_hasta: form.f_hasta,
    id_expte: form.expediente.id,
    usar_perfil_consulta: (usuarioActivo.value?.id_perfil_consulta === 2) ? 1 : 0
  };
  //let valExpteBusq: boolean;
  let valBecasBusq: boolean;
  if (habilitarBusq.value) {
    loading.show();
  }
  ocultarGrilla();
  //valExpteBusq = (esExpteCompleto.value) ? (await validarExpediente()) : true;
  //if (valExpteBusq) {
  valBecasBusq = await becasStore.fetchBecas(paramsRequest);
  if (valBecasBusq) {
    mostrarGrilla();
  }
  //}
  if (habilitarBusq.value) {
    loading.hide();
  } else {
    habilitarBusq.value = true;
  }
}

function abrirABM() {
  const parametros = {
    id_beca: null,
    id_tabla_sol: form.solicitante?.id_tabla_sol
  }
  const swal: SweetAlertOptions = {
    icon: "error",
    title: "Error",
    html: "",
  };
  if (!haySolicitante.value) {
    swal.html = 'Por favor, complete el campo "Solicitante".';
    Swal.fire(swal);
    return;
  }
  emits('abrirABM', parametros);
}

onMounted(async () => {
  const idUsuarioActivo: string = permisosAppStore.currentUser!.id_usuario!;
  const promiseUsuarioHab: Promise<Usuariohabilitado | null> = usuariosStore.findUsuarioByIdUsuario(idUsuarioActivo);
  let promisePeriodos: Promise<boolean>;
  let promiseBecarios: Promise<boolean>;
  let promiseBloques: Promise<boolean>;
  let promiseBaproSucursales: Promise<boolean>;
  let promiseSolicitantes: Promise<boolean>;
  let promiseSolicitante: Promise<Solicitante | null>;
  let promises: Promise<unknown>[] = [];
  let solicitante: Solicitante | null;
  loading.show();
  becasStore.clearBecas();
  form.solicitante = undefined;
  promises.push(promiseUsuarioHab);
  if (isEmpty(periodosStore.periodos.listado) || isEmpty(becariosStore.becarios) || isEmpty(bloquesStore.bloques) || isEmpty(baproSucursalesStore.getBaproSucursales())) {
    promisePeriodos = periodosStore.fetchPeriodos();
    promiseBecarios = becariosStore.fetchBecarios();
    promiseBloques = bloquesStore.fetchBloques();
    promiseBaproSucursales = baproSucursalesStore.fetchBaproSucursales();
    promises.push(promisePeriodos, promiseBecarios, promiseBloques, promiseBaproSucursales);
  }
  if (!isEmpty(props.idTablaSol)) {
    promiseSolicitante = solicitantesStore.findSolicitante(props.idTablaSol!, true);
    promises.push(promiseSolicitante);
    habilitarBusq.value = false;
  } else {
    promiseSolicitantes = solicitantesStore.fetchSolicYProyectos();
    promises.push(promiseSolicitantes);
  }
  await Promise.all(promises).then(async (values) => {
    //if (!Swal.isVisible()) {
    if (Swal.getIcon()?.classList.contains("swal2-error") !== true) {
      usuarioActivo.value = await promiseUsuarioHab;
      usuarioActivo.value!.id_perfil_consulta = Number(usuarioActivo.value?.id_perfil_consulta);
      solicitante = promises.includes(promiseSolicitante) ? (await promiseSolicitante) : null;
      form.solicitante = (solicitante !== null) ? solicitante : undefined;
      form.f_desde = String(periodoActivo.value!.anioActivo) + '-03-01';
      form.f_hasta = String(periodoActivo.value!.anioActivo) + '-12-31';
      /*
      if (haySolicitante.value) {
        validarBuscarBecas();
      } else {
        form.expediente = expedientePorDefecto();
        loading.hide();
      }
      */
      if (!haySolicitante.value) {
        form.expediente = expedientePorDefecto();
        //loading.hide();
      }
    }
    //else {
    loading.hide();
    //}
  }).catch(function () {
    loading.hide();
  });
})
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
